;;; -*- lexical-binding: t -*-

(defun gcdi-interpreted-lexical (a b)
  (let ((x a) (y b) r)
    (while (not (zerop y))
      (setq r (mod x y) x y y r))
    x))

(defun gcdi-compiled-lexical (a b)
  (let ((x a) (y b) r)
    (while (not (zerop y))
      (setq r (mod x y) x y y r))
    x))
(byte-compile 'gcdi-compiled-lexical)

(defun gcdr-interpreted-lexical (a b)
  (if (zerop b)
      a
    (gcdr-interpreted-lexical b (mod a b))))

(defun gcdr-compiled-lexical (a b)
  (if (zerop b)
      a
    (gcdr-compiled-lexical b (mod a b))))
(byte-compile 'gcdr-compiled-lexical)

(defun benchmark-str (result)
  (if (zerop (nth 1 result))
      (format "%.2fs" (car result))
    (format "%.2fs (%.2fs in %d GCs)" (car result)
            (nth 2 result) (nth 1 result))))

(defun gcd-lexical-benchmarks ()
  (interactive)
  (insert "|LEXICAL | interpreted | compiled|\n")
  (insert "|-\n")
  (insert "|recursive|")
  (insert (benchmark-str
           (benchmark-run 80000
             (gcdr-interpreted-lexical 14472334024676221 8944394323791464))))
  (insert "|")
  (insert (benchmark-str
           (benchmark-run-compiled 80000
             (gcdr-compiled-lexical 14472334024676221 8944394323791464))))
  (insert "|\n")

  (insert "|iterative|")
  (insert (benchmark-str
           (benchmark-run 80000
             (gcdi-interpreted-lexical 14472334024676221 8944394323791464))))
  (insert "|")
  (insert (benchmark-str
           (benchmark-run-compiled 80000
             (gcdi-compiled-lexical 14472334024676221 8944394323791464))))
  (insert "|\n"))
